program zapped;

{$mode objfpc}{$H+}

uses
    Classes,
    DateUtils,
    mystuff,
    StrUtils,                                               // intToBin
    sysutils,                                               // dateTimeToSTR
    zappedlib
    ;

var
    INT                                 : stt_bits4;
    currentIRQ                          : boolean;
    lastIRQ                             : boolean;
    z                                   : zappedT;

begin

writeln('zapped begins ', DateTimeToStr(now));
flush(output);

z := zappedT.create;
//z.test;
//exit;

// clear any existing interrupts
INT := z.INT;                                               // get contents of INT register
sleep(100);                                                  // sleep is FPC version of delay

lastIRQ := false;

while (true) do begin
    currentIRQ := z.IRQ;                                    // get state of IRQ pin
    if currentIRQ <> lastIRQ then begin
        if currentIRQ = false then begin
            writeln(FormatDateTime('yy/mm/dd hh:nn:ss', now),
                ' currentIRQ now LOW');
            flush(output);
            end
        else begin
            writeln(DateTimeToStr(now), ' currentIRQ now HIGH');
            sleep(10);                                      // wait 10msecs from time IRQ goes high before reading registers
            z.getRegs;                                      // copy registers from detector to memory
            write  (FormatDateTime('yy/mm/dd hh:nn:ss', now));
            write  ('(', FormatDateTime('hh:nn', IncHour(now,+7)), ' GMT)');
            write  (', INT: 0b', intToBin(z.INT,4), ', Dist: ', z.distanceToStorm);
            write  (', Energy: ', z.energy);
            writeln;
            if z.INT <> 4 then
                z.dumpRegs;
            flush(output);
            end;
        lastIRQ := currentIRQ;
        end;
    sleep(500);   // need plenty of time before checking IRQ again
    end; // while

z.free;

writeln('zapped ends.');
end.

